#ifndef MSP_DATAFILE_PARSERMODE_H_
#define MSP_DATAFILE_PARSERMODE_H_

#include <msp/core/noncopyable.h>
#include "statement.h"

namespace Msp {
namespace DataFile {

class Input;
class Loader;
class LoaderAction;

/**
Base class for parse modes.
*/
class ParserMode: private NonCopyable
{
protected:
	Input &in;
	const std::string &src;

	ParserMode(Input &i, const std::string &s): in(i), src(s) { }
public:
	virtual ~ParserMode() { }

	virtual Statement parse() = 0;
	virtual void process_control_statement(const Statement &) { }

	virtual const StatementKey *peek(unsigned) { return 0; }
	virtual bool parse_and_load(unsigned, Loader &, const LoaderAction &) { return false; }
};

} // namespace DataFile
} // namespace Msp

#endif
